# Poco::Net

# class HTTPSession

Library: Net
Package: HTTP
Header: Poco/Net/HTTPSession.h

## Description

HTTPSession implements basic HTTP session management for both HTTP clients and HTTP servers.

HTTPSession implements buffering for HTTP connections, as well as specific support for the various HTTP stream classes.

This class can not be instantiated. HTTPClientSession or HTTPServerSession must be used instead.

## Inheritance

Known Derived Classes: HTTPClientSession, HTTPServerSession, HTTPSClientSession

## Member Summary

Member Functions: abort, attachSocket, buffered, close, connect, connected, detachSocket, get, getKeepAlive, getTimeout, networkException, peek, read, receive, refill, setException, setKeepAlive, setTimeout, socket, write

## Enumerations

### Anonymous

HTTP_PORT = 80

## Constructors

### HTTPSession

HTTPSession();

Creates a HTTP session using an unconnected stream socket.

### HTTPSession

HTTPSession(
const StreamSocket & socket
);

Creates a HTTP session using the given socket. The session takes ownership of the socket and closes it when it's no longer used.

### HTTPSession

HTTPSession(
const StreamSocket & socket,
bool keepAlive
);

Creates a HTTP session using the given socket. The session takes ownership of the socket and closes it when it's no longer used.

## Destructor

### ~HTTPSession

virtual ~HTTPSession();

Destroys the HTTPSession and closes the underlying socket.

## Member Functions

### abort

void abort();

Aborts a session in progress by shutting down and closing the underlying socket.

### connected

bool connected() const;

Returns true if the underlying socket is connected.

### detachSocket

StreamSocket detachSocket();

Detaches the socket from the session.

The socket is returned, and a new, uninitialized socket is attached to the session.

### getKeepAlive

bool getKeepAlive() const;

Returns the value of the keep-alive flag for this session.

### getTimeout

Poco::Timespan getTimeout() const;

Returns the timeout for the HTTP session.

### networkException

const Poco::Exception * networkException() const;

If sending or receiving data over the underlying socket connection resulted in an exception, a pointer to this exception is returned.

Otherwise, NULL is returned.

### setKeepAlive

void setKeepAlive(
bool keepAlive
);

Sets the keep-alive flag for this session.

If the keep-alive flag is enabled, persistent HTTP/1.1 connections are supported.

### setTimeout

void setTimeout(
const Poco::Timespan & timeout
);

Sets the timeout for the HTTP session.

### attachSocket

void attachSocket(
const StreamSocket & socket
);

Attaches a socket to the session, replacing the previously attached socket.

### buffered

int buffered() const;

Returns the number of bytes in the buffer.

### close

void close();

Closes the underlying socket.

### connect

virtual void connect(
const SocketAddress & address
);

Connects the underlying socket to the given address and sets the socket's receive timeout.

### get

int get();

Returns the next byte in the buffer. Reads more data from the socket if there are no bytes left in the buffer.

### peek

int peek();

Peeks at the next character in the buffer. Reads more data from the socket if there are no bytes left in the buffer.

### read

virtual int read(
char * buffer,
std::streamsize length
);

Reads up to length bytes.

If there is data in the buffer, this data is returned. Otherwise, data is read from the socket to avoid unnecessary buffering.

### receive

int receive(
char * buffer,
int length
);

Reads up to length bytes.

### refill

void refill();

Refills the internal buffer.

### setException

void setException(
const Poco::Exception & exc
);

Stores a clone of the exception.

### socket

StreamSocket & socket();

Returns a reference to the underlying socket.

### write

virtual int write(
const char * buffer,
std::streamsize length
);

Writes data to the socket.